<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iNumReg Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iNumReg Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iNumReg" --><!-- doxytag: inherits="iBase" -->
<p>This interface is used for ID -&gt; iCelEntity* registers in the physical layer.  
 <a href="structiNumReg.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="numreg_8h_source.html">physicallayer/numreg.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iNumReg:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiNumReg.png" usemap="#iNumReg_map" alt=""/>
  <map id="iNumReg_map" name="iNumReg_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,62,24"/>
</map>
 </div></div>

<p><a href="structiNumReg-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#ac58de74c1a716b2cba13a917ef59f2b6">Clear</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes all objects from the registry.  <a href="#ac58de74c1a716b2cba13a917ef59f2b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a942fda5440db2b741bdf36452398c72c">Get</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the object with ID id from the list.  <a href="#a942fda5440db2b741bdf36452398c72c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a6035c209f6f13e3ebd585fee71a2de17">GetSize</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the size of the buffer (This is NOT the count of objects in the registry).  <a href="#a6035c209f6f13e3ebd585fee71a2de17"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a7bae6564611f85cd8cf64c2117f7b501">Register</a> (void *obj)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Registers an object in the registry and returns the new ID, in error case ID 0 is returned.  <a href="#a7bae6564611f85cd8cf64c2117f7b501"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a2a6bb44a69c6ea49a4d9a0139791782d">RegisterWithID</a> (void *obj, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Registers an object in the registry with the provided ID.  <a href="#a2a6bb44a69c6ea49a4d9a0139791782d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a97ac47fa228d0b651c383c810520db71">Remove</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a registered object from the registry.  <a href="#a97ac47fa228d0b651c383c810520db71"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiNumReg.html#a825e21b68844a8eeb8e0b9bb83a468a4">Remove</a> (void *obj)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a registered object from the registry (Note: this is slow, whatever the implementation you choose)  <a href="#a825e21b68844a8eeb8e0b9bb83a468a4"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This interface is used for ID -&gt; iCelEntity* registers in the physical layer. </p>
<p>Currently, two implementations are available:</p>
<ul>
<li>cel.numreg.lists (using arrays) This version is more effective if you don't care of the IDs used and if all the ID will be contiguous. This is usually the case of a server or a single app.</li>
<li>cel.numreg.hash (using hashs) This version is more effective if you want to allow any kind of ID used. This is usually the case of client apps.</li>
</ul>
<p>You can choose between these two implementations with the iCelPlLayer::ChangeNumReg function. </p>

<p>Definition at line <a class="el" href="numreg_8h_source.html#l00041">41</a> of file <a class="el" href="numreg_8h_source.html">numreg.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ac58de74c1a716b2cba13a917ef59f2b6"></a><!-- doxytag: member="iNumReg::Clear" ref="ac58de74c1a716b2cba13a917ef59f2b6" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiNumReg.html#ac58de74c1a716b2cba13a917ef59f2b6">iNumReg::Clear</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes all objects from the registry. </p>

</div>
</div>
<a class="anchor" id="a942fda5440db2b741bdf36452398c72c"></a><!-- doxytag: member="iNumReg::Get" ref="a942fda5440db2b741bdf36452398c72c" args="(uint id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void* <a class="el" href="structiNumReg.html#a942fda5440db2b741bdf36452398c72c">iNumReg::Get</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the object with ID id from the list. </p>

</div>
</div>
<a class="anchor" id="a6035c209f6f13e3ebd585fee71a2de17"></a><!-- doxytag: member="iNumReg::GetSize" ref="a6035c209f6f13e3ebd585fee71a2de17" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiNumReg.html#a6035c209f6f13e3ebd585fee71a2de17">iNumReg::GetSize</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the size of the buffer (This is NOT the count of objects in the registry). </p>
<p>It is the size of array if you use array implementation, the size of the hash otherwise. </p>

</div>
</div>
<a class="anchor" id="a7bae6564611f85cd8cf64c2117f7b501"></a><!-- doxytag: member="iNumReg::Register" ref="a7bae6564611f85cd8cf64c2117f7b501" args="(void *obj)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> <a class="el" href="structiNumReg.html#a7bae6564611f85cd8cf64c2117f7b501">iNumReg::Register</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Registers an object in the registry and returns the new ID, in error case ID 0 is returned. </p>

</div>
</div>
<a class="anchor" id="a2a6bb44a69c6ea49a4d9a0139791782d"></a><!-- doxytag: member="iNumReg::RegisterWithID" ref="a2a6bb44a69c6ea49a4d9a0139791782d" args="(void *obj, uint id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiNumReg.html#a2a6bb44a69c6ea49a4d9a0139791782d">iNumReg::RegisterWithID</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Registers an object in the registry with the provided ID. </p>
<p>You should call this function only if you are sure the ID isn't allocated yet. It is also advised to use the hash implementation for memory reasons. </p>

</div>
</div>
<a class="anchor" id="a97ac47fa228d0b651c383c810520db71"></a><!-- doxytag: member="iNumReg::Remove" ref="a97ac47fa228d0b651c383c810520db71" args="(uint id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiNumReg.html#a97ac47fa228d0b651c383c810520db71">iNumReg::Remove</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes a registered object from the registry. </p>

</div>
</div>
<a class="anchor" id="a825e21b68844a8eeb8e0b9bb83a468a4"></a><!-- doxytag: member="iNumReg::Remove" ref="a825e21b68844a8eeb8e0b9bb83a468a4" args="(void *obj)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiNumReg.html#a97ac47fa228d0b651c383c810520db71">iNumReg::Remove</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes a registered object from the registry (Note: this is slow, whatever the implementation you choose) </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="numreg_8h_source.html">numreg.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
